#
# spec file for package openssh-askpass-gnome (Version 5.2p1)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           openssh-askpass-gnome
BuildRequires:  gtk2-devel krb5-devel opensc-devel openssh openssl-devel pam-devel tcpd-devel update-desktop-files
License:        BSD3c(or similar)
Group:          Productivity/Networking/SSH
Version:        5.2p1
Release:        9
Requires:       openssh = %{version} openssh-askpass = %{version}
AutoReqProv:    on
Summary:        A GNOME-Based Passphrase Dialog for OpenSSH
Url:            http://www.openssh.com/
%define _name openssh
Source:         %{_name}-%{version}.tar.bz2
Patch:          %{_name}-%{version}.dif
Patch15:        %{_name}-%{version}-pam-fix2.diff
Patch18:        %{_name}-%{version}-saveargv-fix.diff
Patch19:        %{_name}-%{version}-pam-fix3.diff
Patch21:        %{_name}-%{version}-gssapimitm.patch
Patch26:        %{_name}-%{version}-eal3.diff
Patch27:        %{_name}-%{version}-engines.diff
Patch28:        %{_name}-%{version}-blocksigalrm.diff
Patch29:        %{_name}-%{version}-pam-fix4.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
SSH (Secure Shell) is a program for logging into a remote machine and
for executing commands on a remote machine. This package contains a
GNOME-based passphrase dialog for OpenSSH.



Authors:
--------
    Aaron Campbell
    Bob Beck
    Markus Friedl
    Niels Provos
    Theo de Raadt
    Dug Song
    Ben Taylor <bent@clark.net>
    Chip Salzenberg <chip@valinux.com>
    Chris Saia <csaia@wtower.com>
    Dan Brosemer <odin@linuxfreak.com>
    Jim Knoble <jmknoble@pobox.com>
    Marc G. Fournier <marc.fournier@acadiau.ca>
    Nalin Dahyabhai <nalin.dahyabhai@pobox.com>
    Niels Kristian Bech Jensen <nkbj@image.dk>
    Phil Hands <phil@hands.com>
    Thomas Neumann <tom@smart.ruhr.de>
    Tudor Bosman <tudorb@jm.nu>
    Damien Miller <djm@ibs.com.au>

%define prefix   /usr

%prep
%setup -q -n %{_name}-%{version}
%patch 
%patch15
%patch18
%patch19
%patch21
%patch26 -p1
%patch27 -p1
%patch28
%patch29 -p1

%build
%{?suse_update_config:%{suse_update_config}}
aclocal
autoheader
autoconf
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" \
./configure \
	--mandir=%{_mandir} \
	--prefix=%{prefix} \
	--infodir=%{_infodir} \
	--sysconfdir=/etc/ssh \
	--libexecdir=%{prefix}/%_lib/ssh \
	--with-tcp-wrappers \
	--with-pam \
	--with-kerberos5=/usr \
	--with-privsep-path=/var/lib/empty \
        --with-opensc \
	--disable-strip \
        --target=%{_target_cpu}-suse-linux
cd contrib
make %{?jobs:-j%jobs} gnome-ssh-askpass2
mv gnome-ssh-askpass2 gnome-ssh-askpass

%install
install -d -m 755 $RPM_BUILD_ROOT/usr/%_lib/ssh/
install contrib/gnome-ssh-askpass $RPM_BUILD_ROOT/usr/%_lib/ssh/gnome-ssh-askpass

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(0755,root,root) /usr/%_lib/ssh/gnome-ssh-askpass

%changelog
